#!/bin/bash

#version 0.4
#Detecter les questions dans deux lignes

#Version 0.3:
#Insérer des //Question NUM : Name : .... et [html]
#Corriger la syntaxe des QCM à réponse multiple (enlever le "=")
#Ajouter un "#" à la fin de chaque réponse

#Version 0.2:
#-corrigés erreurs syntaxe *.gift
#-changer les pourcentages des questions: toutes les questions 100%)
#-Utiliser unoconv au lieu de libreoffice

# $N = REPERTOIRES

create_aiken_gift(){
    FILE="$1"
echo "2 $FILE"
#libreoffice --headless --convert-to odt  "$FILE"
unoconv -f odt "$FILE"
ls *.odt
QCM_ODT="${FILE%.docx}.odt"
echo "${QCM_ODT}"
###############   Garder les réponses correctes ########################################################################################
#Uncompress *.odt
unzip -q "${QCM_ODT}" -d "${QCM_ODT%.odt}"

#Inserer des sauts de ligne pour que sed puisse travailler mieux avec, en créant un fichier auxilier "${QCM_ODT%.odt}"/content.txt
sed 's/\([^\]>\)/\1\n/g' "${QCM_ODT%.odt}/content.xml" >"${QCM_ODT%.odt}/content.txt"

#Identifier les style:name qui ont couleur police "rouge 3", et les stocker dans l'array NAME
NAME=($(sed -n 'N;s/<style:style style:family=\"text\" style:name=\"\([A-Z][0-9]\+\)\">.\+fo:color=\"#ff0000\".*/\1/pg;s/<style:style style:name=\"\([A-Z][0-9]\+\)\" style:family=\"text\">.\+fo:color=\"#ff0000\".*/\1/pg;D' "${QCM_ODT%.odt}/content.txt"))

#Chercher les réponses en "rouge 3" ,et leur ajouter un "=" devant pour les identifier comme correctes
TOTAL_REGEXP="<text:span text:style-name=\"${NAME[0]}\">"
N=1
while [[ "${NAME[${N}]}" ]];do
  TOTAL_REGEXP="${TOTAL_REGEXP}\|<text:span text:style-name=\"${NAME[${N}]}\">"
  ((N+=1))
done
sed -i "/${TOTAL_REGEXP}/,+1 s/^\([a-zA-Z]\)<\/text:span>/=\1<\/text:span>/g" "${QCM_ODT%.odt}/content.txt"

#Supprimer les sauts de ligne inserés pour travailler avec sed, et storer sur "${QCM_ODT%.odt}"/content.xml de nouveau
tr -d '\n' <"${QCM_ODT%.odt}"/content.txt >"${QCM_ODT%.odt}/content.xml"

#On peur supprimer le fichier auxilier "${QCM_ODT%.odt}"/content.txt
rm "${QCM_ODT%.odt}"/content.txt

#Compreser de nouveau (premier supprimer "${QCM_ODT}")
rm "${QCM_ODT}"
cd "${QCM_ODT%.odt}"
zip -q -0 -X "${QCM_ODT}" mimetype
zip -q -r "${QCM_ODT}" * -x mimetype
mv "${QCM_ODT}" ..
cd ..

# Maintenant on l'info des réponses correctes dans "${QCM_ODT}"

#Convertir vers *.txt
#libreoffice --headless --convert-to "txt:Text (encoded):UTF8" "${QCM_ODT}"
unoconv -f txt -e FilterOptions=UTF8,LF "${QCM_ODT}"
rm -R "${QCM_ODT%.odt}"
rm "${QCM_ODT}"
#Créer les variables qui gardent les noms des fichiers
QCM_TXT="${QCM_ODT%.odt}.txt"
QCM_AIKEN="${QCM_ODT%.odt}.aiken"
QCM_GIFT="${QCM_ODT%.odt}.gift"
#Trouver la ligne ou commencent les questions
LIGNE=$(( $(sed -n '/Question n°/ =' "$QCM_TXT"| head -1)-2 ))
#Supprimer les lignes d'entête qui ne servent à rien
sed -i "1,+${LIGNE} d" "$QCM_TXT"
#Supprimer les lignes à la fin qui ne servent à rien
sed -i '/Date de l’évaluation/,$ d' "$QCM_TXT"
#Mieux supprimer les "0" à gauche
sed -i 's/Question n°0\([0-9]\)/Question n°\1/g' "$QCM_TXT"
#Jusqu'ici les modificatons comunes. Maintenant on fait deux copies et on peu virer les ofichier auxilier "$QCM_TXT"
cp "$QCM_TXT" "$QCM_AIKEN"
cp "$QCM_TXT" "$QCM_GIFT"
#rm "$QCM_TXT"
###############  Exporter vers *.aiken   ########################################################################################
#transformation des a b c en A B C
sed -i 's/\(^.$\|^=.$\)/\U\1/' "$QCM_AIKEN"
#Garder les réponses correctes à la fin de chaque de chaque bloc question-réponses dans une ligne ANSWER:
#Il faut garder les numeros tel qu'il apparaitrent dans le fichier. Quelques fois avec un "0" à gauche
NUM_QUEST=$(cat "$QCM_AIKEN"|sed -n 's/Question n°\([0-9]*\).*/\1/p'|tail -1)
N=1
while [[ "$N" -le "$NUM_QUEST" ]];do
  ANSWER[$N]=$(sed -n "/Question n°${N}[^0-9]/,/^$/ s/^=\([A-Z]\)$/\1,/p" "$QCM_AIKEN" | tr -d '\n'|sed 's/,$//g')
  ROW=$(sed -n "/Question n°${N}[^0-9]/,/^$/=" "$QCM_AIKEN"|tail -1)
  sed -i "${ROW} i ANSWER: ${ANSWER[${N}]}" "$QCM_AIKEN"
  (( N+=1 ))
done
#Maintenant qu'on a gardé les réponses correctes, on peut supprimer les caractères "="
sed -i '/^=[A-Z]$/ s/=//' "$QCM_AIKEN"
#Quand on a une seule letre mayuscule,on supprime les sauts de ligne et ajoute un .et un espace après le point
sed -i '/^[A-Z]$/ N;s/\n/\.\ /' "$QCM_AIKEN"
#supprime tous les points à la fin de chaque ligne
sed -i 's/\.\+[ \t]*$//' "$QCM_AIKEN"
#supprime les lignes qui commencent par (
sed -i '/^(/d' "$QCM_AIKEN"
#Si on  veut specifier le nombre de réponses correctes, on comente la ligne anterieure et on dé-comente la suivante:
#sed -i '/^Question/N;s/\n/ /;s/).*/)/' "$QCM_AIKEN"
#Supprime tous les "Questions N°2: " "Questions N°3: " "Questions N°4: " etc...
sed -i 's/Question n.[0-9].*: *//' "$QCM_AIKEN"
#Supprime les lines vides répétées
cat -s "$QCM_AIKEN" > "$QCM_AIKEN".tmp && cat "$QCM_AIKEN".tmp > "$QCM_AIKEN" && rm "$QCM_AIKEN".tmp

###############  Exporter vers *.gift   ########################################################################################
#Detecter Questions en deux lignes
sed -i '/^Question/N; /\n^=\?[a-zA-Z]\{1\}$\|\n(.*réponse.*).*$/! s/\n/ /' "$QCM_GIFT"
#Quand on a [= + une seule letre] au debut de ligne, on supprime la letre et le saut de ligne
sed -i '/^=[a-zA-Z]$/ N;s/\(^=\)[a-zA-Z]\n\(.*\)/\1\2/' "$QCM_GIFT"
#Quand on a une seule letre au debut de ligne,on substitue la letre par un "~" et on supprime le saut de ligne
sed -i '/^[a-zA-Z]$/ N;s/^[a-zA-Z]\n\(.*\)/~\1/' "$QCM_GIFT"
N=1
while [[ "$N" -le "$NUM_QUEST" ]];do
  REPONSES_INCORRECTES=$(sed -n "/Question n°${N}[^0-9]/,/^$/p" "$QCM_GIFT"|grep "~" -c)
  REPONSES_CORRECTES=$(sed -n "/Question n°${N}[^0-9]/,/^$/p" "$QCM_GIFT"|grep "=" -c)
  POURCENTAGE_INCORRECTE[$N]=$( echo "100/${REPONSES_INCORRECTES}"|bc -l|sed 's/^\./0./;s/\([0-9]\+\.[0-9]\{5\}\)[0-9]*/\1/')
  POURCENTAGE_CORRECTE[$N]=$( echo "100/${REPONSES_CORRECTES}"|bc -l|sed 's/^\./0./;s/\([0-9]\+\.[0-9]\{5\}\)[0-9]*/\1/')
  sed -i "/Question n°${N}[^0-9]/,/^$/ s/^~\(.*\)/~%-${POURCENTAGE_INCORRECTE[$N]}%\1/" "$QCM_GIFT"
if [[ "$REPONSES_CORRECTES" == "1" ]];then
  sed -i "/Question n°${N}[^0-9]/,/^$/ s/^=\(.*\)/=\1/" "$QCM_GIFT"
else
  sed -i "/Question n°${N}[^0-9]/,/^$/ s/^=\(.*\)/~%${POURCENTAGE_CORRECTE[$N]}%\1/" "$QCM_GIFT"
fi
ROW=$(sed -n "/Question n°${N}[^0-9]/,/^$/=" "$QCM_GIFT"|tail -1)
  sed -i "$ROW i }" "$QCM_GIFT"
  (( N+=1 ))
done

#supprime les lignes qui commencent par (
sed -i '/^(/d' "$QCM_GIFT"
#Si on  veut specifier le nombre de réponses correctes, on comente la ligne anterieure et on dé-comente la suivante:
#                sed -i '/^Question/N;s/\n/ /;s/).*/)/' "$QCM_GIFT"
#Substituer les "Questions n°1: " etc... par "::"
sed -i 's/Question n.\([0-9]\+\).*: *\(.*\)$/\/\/Question: \1 Name: \2\n::\2::[html]\2{/' "$QCM_GIFT"
#Dans les réponses, supprimer les . finales (s'ils éxistent) et ajouter un # à le final de la ligne
sed -i '/^~.*/ s/\.\? *$/#/' "$QCM_GIFT"
sed -i '/^=.*/ s/\.\? *$/#/' "$QCM_GIFT"
#Supprime les lines vides répétées
cat -s "$QCM_GIFT" > "$QCM_GIFT".tmp && cat "$QCM_GIFT".tmp > "$QCM_GIFT" && rm "$QCM_GIFT".tmp
}

####################### START OF THE SCRIPT   ################################################################################


if [[ -n $(ps x|grep soffice|grep libreoffice) ]];then
  if [ -x /usr/bin/zenity ];then
    zenity --no-wrap  --info --text "Libreoffice must be closed to convert office documents.\nClose any Libreoffice instance and try again."
    exit 1
  else
    #If there isn't zenity, we will use command line interface
    echo "Error: To convert office documents is necessary there isn't any Libreoffice instance running"
    echo "Close any Libreoffice instance and try again"
    exit 1
  fi
fi

while [[ "$1" ]];do
  cd "$1"
  while read "QCM_DOCX" ;do
  echo "1 $QCM_DOCX"
    create_aiken_gift "$QCM_DOCX"
  done < <(ls .|grep '\.docx')
shift
done